inlets = 1;
outlets = 1;

const nPresets = 5;
const matrixDim = 8; //  dimensions of matrix object are variable
const chipDim = 5; // dimensions on chip ar fixed
const matrixSize = matrixDim * matrixDim;

var allSettings = new Array(); // an array of arrays, of which the first is reserverd for current, the rest for preset settings
var oscString = new Array();

var theMatrix;
var rowCount = 0;


function loadbang() { // initialization procedure
	theMatrix = this.patcher.getnamed("•matrix");
	oscString = [0, 0, 0, 0, 0, 0, 0, 0, 0]; // 9 32bit values
	resetPresets();
	theMatrix.message('rows', matrixDim);
	theMatrix.message('columns', matrixDim);
}

function bang() { // when js object receives bang
	outOSC(0); // send current connections as OSC string
}


function list() { // when js object receives list
	var inList = arguments;
	var listLen = inList.length;
	switch (listLen) {
		case matrixDim:
			rowByRow(inList);
		break;
		case 3:
			dumpRows();
		break;
		case 9:
			returnOSC(inList);
		break;
	}
}

function clearMatrix() { // clear all matrix connections
	for (var i=0; i<matrixSize; i+=1) {
		allSettings[0][i] = 0;
	}
	recallPreset(0); // 0 is not really a preset, but the current connections, at this point all set to 0
}


function dumpRows() { // dump as many rows as the matrix contains
	for(rowCount=0; rowCount<matrixDim; rowCount+=1) { // rowCount is global variable
		theMatrix.message("getrow", rowCount); // result triggers the rowByRow function
	}
	outOSC(0); // send current connections as OSC string
}


function rowByRow (matrixRow) { // add row by row to the first array in the allSettings array
	var offset = rowCount * matrixDim; // offset into the array dependent on row (rowCount is global variable)
	var item = 0;
	for(var i=0; i<matrixDim; i+=1) {
		item = matrixRow [i];
		allSettings[0][offset + i] = item; // create a single array (size: matrixSize) containing all connection values
	}
}

function returnOSC(inList) {
	//post(inList + '\n');
	//outlet(0, inList.length);
	//clearMatrix();
	recallPreset(0);
}


function outOSC(ix) {
	var nBytes = matrixSize / 32; // one byte is 32 bits
	var thisBit = 0;
	var thisByte = 0;
	for (var i=0; i<nBytes; i+=1) {
		thisByte = 0; // reset byte
		for (var b=0; b<32; b+=1) {
			thisBit = i*32 + b; // ofset into matrix
			thisByte = thisByte << 1; // shift byte one position to left...
			thisByte += allSettings[ix][thisBit]; // ...and add one bit
		}
		oscString[i+1] = thisByte; // first byte is settings
	}
	outlet(0, '/ca' , oscString);
}

function savePreset(presetnr) {
	for (var i=0; i<matrixSize; i+=1) {
		allSettings[presetnr][i] = allSettings[0][i];
	}
}

function recallPreset(presetnr) {
	var index = 0
	var item = 0;
	for (var i=0; i<matrixDim; i+=1) {
		for (var j=0; j<matrixDim; j+=1) {
			index = i * matrixDim + j;
			item = allSettings[presetnr][index];
			allSettings[0][index] = item;
			theMatrix.message('set', j, i, item);
		}
	}
	outOSC(0); // send current connections as OSC string
}



function resetPresets () {
	for(var i=0; i<=nPresets; i+=1) {
		var preset = new Array();
		for (var j=0; j<matrixSize; j+=1) {
			preset.push(0);
		}
		allSettings.push(preset);
	}
	outOSC(0); // send current connections as OSC string
}